/* TSAppManager.h created by tsengel on Thu 14-Aug-1997 */

#import <AppKit/AppKit.h>

@class TSShelfWindow;


@interface TSAppManager : NSObject
{
    id		infoPanel;

    TSShelfWindow *	shelfWindow;

    // Lots of views from our shelf...we need them for the wiring them up properly.

    id		shelfContentView;
    id		swapView;
    id		tabMatrix;
    id		desktopFakeView;
    id		dragMasterView;
    NSRect	_fixedMatrixRect;

    id		renamingText;

    // Prefs items

    id		preferencesPanel;

    id		windowLevelMatrix;
    id		workspaceThreadingSwitch;
    id		shelfAutohideSwitch;
    id		desktopColorPrefWell;

    id		renamingPanel;
}

- (void)applicationDidFinishLaunching:(NSNotification *)notification;

- (void)showPreferencesPanel:(id)sender;
- (void)registerDefaults;
- (void)preparePrefsPanel;
- (void)preferencesChanged:(id)sender;
- (void)desktopColorChanged:(id)sender;
- (BOOL)loadAllShelfLevels;

- (void)applicationDidHide:(NSNotification *)aNotification;
- (void)applicationWillTerminate:(NSNotification *)aNotification;
- (BOOL)application:(NSApplication *)application openFile:(NSString *)filename;

- (void)open:(id)sender;
- (BOOL)_openFile:(NSString *)filename;

- (void)addShelfLevel:(id)sender;
- (void)addIconShelfLevel:(id)sender;
- (void)addTextShelfLevel:(id)sender;
- (void)addTrayShelfLevel:(id)sender;
- (id)newItemWithName:(NSString *)bundleName;
- (id)newItemWithPath:(NSString *)shelfPath;

- (void)addShelfLevelItem:(id)newItem;

- (void)shiftShelfTabLeft:(id)sender;
- (void)shiftShelfTabRight:(id)sender;
- (void)showRenamingPanel:(id)sender;
- (void)renameShelfLevel:(id)sender;

- (void)removeShelfLevel:(id)sender;

- (void)saveShelfs:(id)sender;

- (void)showInfoPanel:sender;

- (void)fixSpinningCursorBug;

@end
