/* TSShelfWindow.h created by tsengel on Thu 14-Aug-1997 */

// The current window levels are defined like this... keeping them in mind might make it easier
// to choose our level later on...so I'll keep this part here...
//
// NSNormalWindowLevel			= 0,
// NSFloatingWindowLevel		= 3,
// NSDockWindowLevel			= 5,
// NSSubmenuWindowLevel			= 10,
// NSMainMenuWindowLevel		= 20


#import <AppKit/AppKit.h>

enum
{
    TSShelfBackgroundWindowLevel = NSNormalWindowLevel - 1,
    TSShelfNormalWindowLevel = NSNormalWindowLevel,
    TSShelfForegroundWindowLevel = NSFloatingWindowLevel + 1
};


@interface TSShelfWindow : NSWindow
{
    float		grabBorderHeight;
    float		_lowestYOrigin;
    NSSize		_maxSize;

    BOOL		doesAutoraise;
    BOOL		fullyHidden;
    BOOL		fullyVisible;
}

- (id)initWithContentRect:(NSRect)contentRect styleMask:(unsigned int)aStyle backing:(NSBackingStoreType)bufferingType defer:(BOOL)flag;
- (void)awakeFromNib;
- (void)awake;

- (void)setGrabBorder:(float)height;
- (void)setFrame:(NSRect)frameRect display:(BOOL)flag;

- (void)setAutoRaiseEnabled:(BOOL)flag;
- (BOOL)isAutoRaiseEnabled;
- (void)shouldAutoRaise;
- (void)shouldAutoHide;

- (void)dropToLowerLevel;
- (void)raiseToHigherLevel;

@end
